/****************************************************************************/
/**    Kernel-AX25-Treiber fr GNOM.                                       **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/** Header-File:                                                           **/
/**  Ansteuerung Kernel-AX.25                                              **/
/****************************************************************************/


#include "global.h"
#include <config.h>

#include <sys/socket.h>
#ifdef HAVE_BROKEN_AX25_H
#include "local_ax25.h"
#include <netrose/rose.h>
#elif HAVE_NETAX25_AX25_H
#include <netax25/ax25.h>
#include <netrose/rose.h>
#else
#include <linux/ax25.h>
#include <linux/rose.h>
#endif

//#include <linux/rose.h>   // Wenn dieses #include in den ax25-libs drin ist,
                          // kann es hier 'raus.
// #include <procutils.h>

#ifdef HAVE_NETAX25_AXLIB_H
   #include <netax25/axconfig.h>
   #include <netax25/axlib.h> 
   #include <netax25/procutils.h>
#elif HAVE_AX25_AXUTILS_H
   #include <ax25/axconfig.h>
   #include <ax25/axutils.h>
   #include <ax25/procutils.h>

#else
   #include <axconfig.h>
   #include <axutils.h>
   #include <procutils.h>
#endif


#include <netinet/if_ether.h>
#include <errno.h>




/* Fr dieses QSO die definierten ctl-Werte setzen. (bitte jonny, hi) */
void ax25_set_ctl(int qsonr);



/*
 * Sucht einen freien Platz im QSO-Array und allokiert den ntigen Speicher.
 */
int ax25_newqso();



/*
 * Gibt diese QSO-Nummer und den dazugehrigen Speicher wieder frei
 */
void ax25_freeqso(int qsonr);



/*
 * Kontrolliert, ob der in bergebene port in use_ports steht. Wenn ja wird er
 * attached, ansonsten nicht beachtet
 */
int ax25_valid_port(char *port);



/* Trgt den bergebenen Port in die Portliste eine, und holt noch weitere Infos
 * drber beim Kernel ein.
 */
void ax25_add_port(char *port);



/*
 * ffnet Sockets zu jedem konfigurierten Port
 */
void ax25_open_ports();



/*
 * Holt Kanal-Informationen ber das Kernel-AX25 'rein
 *
 * Rckgabe: FALSE wenn Fehler, TRUE wenn kein Fehler. Fehlermeldungen schreibt die
 * Funktion selbst auf den Schirm.
 */
void ax25_load_info();



/*
 * Alle Kanle disconnecten
 */
void ax25_disconect_all();



/*
 * Das QSO-Array initialisieren, sprich alle Felder auf NULL setzen
 */
void ax25_init_qsos();



/*
 * Ein QSO wurde angenommen. Daten holen, ins QSO-Array eintragen und
 * GNOM bescheid sagen.
 */
void ax25_accept_qso(int fd, s_portinfo *port, char *mycall);



/*
 * Es sind neue QSO-Daten gekommen - Holen und an GNOM schicken
 */
void ax25_get_qso_data(int qsonr);



/*
 * Sucht das zu dem Port gehrende Rufzeichen 'raus und gibt es zurck.
 */
int ax25_get_mycall(char *port, char *mycall);



/*
 * Informationen ber den bergebenen Port holen und zurckgeben.
 */
s_portinfo *ax25_get_portinfo(char *port);



/* Wenn call_without keine SSID hat, wird -0 drangehngt, und 
 * in call_with zurck gegeben.
 */
void ax25_make_ssid_calls(char *call_with, char *call_without);



/*
 * Connect-Versuch. Rckgabe: fd
 */
int ax25_make_connect(char *port, char *mycall, char *call, char *digis, int chan);



/*
 * Alle aktiven AX.25-Kanle pollen, um zu gucken, ob sich im Status
 * etwas getan hat, ob ein Kanal disconnected wurde oder oder oder...
 */
void poll_ax25();


